#This function runs the analysis

fitdemo <- function(start,n.starts,sizeoffset,fixed){
  
  touse <- which( is.na(exp.data$growth)==FALSE& (exp.data$sex=='F' | exp.data$sex=='U') )

  gdata <- exp.data[touse,]
  

  LogLik <- function(b0LP,bzLP,bz2LP,bNLP,
                     b0HP,bzHP,bz2HP,bNHP,
                     philength,phistrat,
                     philengthstrat,
                     sigma) { 
    
    for(i in unique(exp.data$tank)){   
      p.size <- exp.data[which(exp.data$tank==i),'initial.sl']
      p.pheno <- exp.data[which(exp.data$tank==i),'LP']
 

 if(exp.test==TRUE){

       # #exponential
       complength <- array(0,c(length(p.size),length(p.size)))
       for (j in 1:length(p.size)){
         for (k in 1:length(p.size)){
           if (p.pheno[j]==1 & p.pheno[k]==1){
             complength[j,k] <- exp( (philength + philengthstrat)*(p.size[k]) - (philength + philengthstrat)*(p.size[j]) )
           }
           if (p.pheno[j]==1 & p.pheno[k]==0){
             complength[j,k] <- exp(-phistrat) * exp( (philength)*(p.size[k]) - (philength + philengthstrat)*(p.size[j]) )
           }
           if (p.pheno[j]==0 & p.pheno[k]==0){
             complength[j,k] <- exp( (philength)*(p.size[k]) - (philength)*(p.size[j]) )
           }
           if (p.pheno[j]==0 & p.pheno[k]==1){
             complength[j,k] <- exp(phistrat) * exp( (philength + philengthstrat)*(p.size[k]) - (philength)*(p.size[j]) )
           }
         }
       }
 } else{
      #proportional
      complength <- array(0,c(length(p.size),length(p.size)))
      for (j in 1:length(p.size)){
        for (k in 1:length(p.size)){
          if (p.pheno[j]==1 & p.pheno[k]==1){
            complength[j,k] <-  (p.size[k]^(philength + philengthstrat) ) / (p.size[j]^(philength + philengthstrat) )
          }
          if (p.pheno[j]==1 & p.pheno[k]==0){
            complength[j,k] <- exp(-phistrat) * (p.size[k]^(philength) ) / (p.size[j]^(philength + philengthstrat) )
          }
          if (p.pheno[j]==0 & p.pheno[k]==0){
            complength[j,k] <-  (p.size[k]^(philength) ) / (p.size[j]^(philength) )
          }
          if (p.pheno[j]==0 & p.pheno[k]==1){
            complength[j,k] <- exp(phistrat) * (p.size[k]^(philength + philengthstrat) ) / (p.size[j]^(philength) )
          }
        }
      }
    }
      alphaN <- rowSums( complength )
      
      
      if (i==unique(exp.data$tank)[1]){
        long.version <- c(alphaN)
      }
      if (i!=unique(exp.data$tank)[1]){
        long.version <- c(long.version,alphaN)
      }
    }
    
    #need to restrict these to cases used in data set
    long.version <- long.version[touse]
    
    dens.ind <- b0LP*gdata[,'LP'] + bzLP*gdata[,'LP']*log(gdata[,'initial.sl']/sizeoffset) + bz2LP*gdata[,'LP']*log(gdata[,'initial.sl']/sizeoffset)^2 +
                b0HP*gdata[,'HP'] + bzHP*gdata[,'HP']*log(gdata[,'initial.sl']/sizeoffset) + bz2HP*gdata[,'HP']*log(gdata[,'initial.sl']/sizeoffset)^2 
    dens.dep <- bNLP*gdata[,'LP'] * long.version + 
                bNHP*gdata[,'HP'] * long.version
    
    lin.pred <- dens.ind + (dens.dep)
    
  
      loglik <- -sum(dnorm(gdata[,'growth'],lin.pred,sigma,log=TRUE))
     
    
    return(loglik)
  }
  
  results.AIC <- array(NA,c(n.starts,2))
  dimnames(results.AIC) <- list(c(1:n.starts),c('likelihood','AIC'))
  for (i in 1:n.starts){
    
    start = list(b0LP=start.values[i,'b0LP'],bzLP=start.values[i,'bzLP'],bz2LP=start.values[i,'bz2LP'],bNLP=start.values[i,'bNLP'],
                 b0HP=start.values[i,'b0HP'],bzHP=start.values[i,'bzHP'],bz2HP=start.values[i,'bz2HP'],bNHP=start.values[i,'bNHP'],
                 philength=start.values[i,'philength'],phistrat=start.values[i,'phistrat'],philengthstrat=start.values[i,'philengthstrat'],
                 sigma=start.values[i,'sigma'])
    
    
    test <- mle2(minuslogl = LogLik,start=start ,fixed=fixed )                                                     
    
    
    results.AIC[i,1] <- summary(test)@m2logL 
    results.AIC[i,2] <- summary(test)@m2logL + 2 * dim(summary(test)@coef)[1]
    
    
    print(c(i,'-',results.AIC[i,1],'-',summary(test)))
  }
  
  i <- (c(1:n.starts)[which(results.AIC[,1]==min(results.AIC[,1]))])[1]
  start = list(b0LP=start.values[i,'b0LP'],bzLP=start.values[i,'bzLP'],bz2LP=start.values[i,'bz2LP'],bNLP=start.values[i,'bNLP'],
             b0HP=start.values[i,'b0HP'],bzHP=start.values[i,'bzHP'],bz2HP=start.values[i,'bz2HP'],bNHP=start.values[i,'bNHP'],
             philength=start.values[i,'philength'],phistrat=start.values[i,'phistrat'],philengthstrat=start.values[i,'philengthstrat'],
             sigma=start.values[i,'sigma'])
  
  
  test <- mle2(minuslogl = LogLik,start=start ,fixed=fixed  ) 
  results.AIC.final <- results.AIC[i,]
  return(list(results.AIC,summary(test),coef(test),results.AIC.final, test))

}


# Function for fitting model where growth = change in mass

fitdemo.mass <- function(start,n.starts,sizeoffset.mass,fixed){

  touse <- which( is.na(exp.data$growth.mass)==FALSE & (exp.data$sex=='F' | exp.data$sex=='U') )

  gdata <- exp.data[touse,]
  
  LogLik <- function(b0LP,bzLP,bNLP,
                     b0HP,bzHP,bNHP,
                     philength,phistrat,
                     philengthstrat,
                     sigma) { 
    
    for(i in unique(exp.data$tank)){   
      p.size <- exp.data[which(exp.data$tank==i),'initial.mass']
      p.pheno <- exp.data[which(exp.data$tank==i),'LP']
      
      if(exp.test==TRUE){
        
        # #exponential
        complength <- array(0,c(length(p.size),length(p.size)))
        for (j in 1:length(p.size)){
          for (k in 1:length(p.size)){
            if (p.pheno[j]==1 & p.pheno[k]==1){
              complength[j,k] <- exp( (philength + philengthstrat)*(p.size[k]) - (philength + philengthstrat)*(p.size[j]) )
            }
            if (p.pheno[j]==1 & p.pheno[k]==0){
              complength[j,k] <- exp(-phistrat) * exp( (philength)*(p.size[k]) - (philength + philengthstrat)*(p.size[j]) )
            }
            if (p.pheno[j]==0 & p.pheno[k]==0){
              complength[j,k] <- exp( (philength)*(p.size[k]) - (philength)*(p.size[j]) )
            }
            if (p.pheno[j]==0 & p.pheno[k]==1){
              complength[j,k] <- exp(phistrat) * exp( (philength + philengthstrat)*(p.size[k]) - (philength)*(p.size[j]) )
            }
          }
        }
      } else{
        #proportional
        complength <- array(0,c(length(p.size),length(p.size)))
        for (j in 1:length(p.size)){
          for (k in 1:length(p.size)){
            if (p.pheno[j]==1 & p.pheno[k]==1){
              complength[j,k] <-  (p.size[k]^(philength + philengthstrat) ) / (p.size[j]^(philength + philengthstrat) )
            }
            if (p.pheno[j]==1 & p.pheno[k]==0){
              complength[j,k] <- exp(-phistrat) * (p.size[k]^(philength) ) / (p.size[j]^(philength + philengthstrat) )
            }
            if (p.pheno[j]==0 & p.pheno[k]==0){
              complength[j,k] <-  (p.size[k]^(philength) ) / (p.size[j]^(philength) )
            }
            if (p.pheno[j]==0 & p.pheno[k]==1){
              complength[j,k] <- exp(phistrat) * (p.size[k]^(philength + philengthstrat) ) / (p.size[j]^(philength) )
            }
          }
        }
      }
      alphaN <- rowSums( complength )
      
      if (i==unique(exp.data$tank)[1]){
        long.version <- c(alphaN)
      }
      if (i!=unique(exp.data$tank)[1]){
        long.version <- c(long.version,alphaN)
      }
    }
    
    #need to restrict these to cases used in data set
    long.version <- long.version[touse]
    
    dens.ind <- b0LP*gdata[,'LP'] + bzLP*gdata[,'LP']*log(gdata[,'initial.mass']/sizeoffset.mass) + 
                b0HP*gdata[,'HP'] + bzHP*gdata[,'HP']*log(gdata[,'initial.mass']/sizeoffset.mass)
    dens.dep <- bNLP*gdata[,'LP'] * long.version + bNHP*gdata[,'HP'] * long.version
    
    
    lin.pred <- dens.ind + (dens.dep)
    
    loglik <- -sum(dnorm(gdata[,'growth.mass'],lin.pred,sigma,log=TRUE))

    
    return(loglik)
  }
  
  
  results.AIC <- array(NA,c(n.starts,2))
  dimnames(results.AIC) <- list(c(1:n.starts),c('likelihood','AIC'))
  for (i in 1:n.starts){
    
    start = list(b0LP=start.values[i,'b0LP'],bzLP=start.values[i,'bzLP'],bNLP=start.values[i,'bNLP'],
                 b0HP=start.values[i,'b0HP'],bzHP=start.values[i,'bzHP'],bNHP=start.values[i,'bNHP'],
                 philength=start.values[i,'philength'],phistrat=start.values[i,'phistrat'],philengthstrat=start.values[i,'philengthstrat'],
                 sigma=start.values[i,'sigma'])
    
    
    test <- mle2(minuslogl = LogLik,start=start ,fixed=fixed )                                                     
    
    
    results.AIC[i,1] <- summary(test)@m2logL 
    results.AIC[i,2] <- summary(test)@m2logL + 2 * dim(summary(test)@coef)[1]
    
    
    print(c(i,'-',results.AIC[i,1],'-',summary(test)))
  }
  
  i <- (c(1:n.starts)[which(results.AIC[,1]==min(results.AIC[,1]))])[1]
  start = list(b0LP=start.values[i,'b0LP'],bzLP=start.values[i,'bzLP'],bNLP=start.values[i,'bNLP'],
               b0HP=start.values[i,'b0HP'],bzHP=start.values[i,'bzHP'],bNHP=start.values[i,'bNHP'],
               philength=start.values[i,'philength'],phistrat=start.values[i,'phistrat'],philengthstrat=start.values[i,'philengthstrat'],
               sigma=start.values[i,'sigma'])
  
  
  test <- mle2(minuslogl = LogLik,start=start ,fixed=fixed  ) 
  results.AIC.final <- results.AIC[i,]
  return(list(results.AIC,summary(test),coef(test),results.AIC.final,test))
  
}